var Orchestra = (function(undefined) {

	var summer = function(pusher, args, start) {
		for(var i=start; i< args.length; i++){
	      pusher.push(args[i])
		}
		return pusher;
	};


	return  function(call, signals) {
		var perform = [];
		var dataEntity = {};
		var signalLength = 0;
		var calls = {};
		
		
		signalLength = signals.length;

		for(var i = signals.length; i--;){
			dataEntity[signals[i]] = [];
		};
		

		var director =  {
			'emit' : function(signal) {

				if (dataEntity[signal]) {
					perform.push(signal);
					dataEntity[signal] = summer([], arguments, 1);
				}

				if (signalLength === perform.length) {
					call.call(this, dataEntity);
					delete this;
				}
			},
			'on' : function(name , oncall) {
				calls[name] = oncall;
			},
			'emitter' : function(signal) {
				return function() {
					//if (calls['before-'+signal]) {
					//	calls['before-'+signal].call(this, arguments);
					//}
					
					
					director.emit.call(this, signal, summer([signal], arguments, 1));

					// if (calls['after-'+signal]) {
					// 						calls['after-'+signal].call(this, arguments);
					// 					}
				}
			},
			
			'emitEach' : function() {
				
				var i = 1;
				return function(data) {
					if (calls['before-iteration']) {
						calls['before-iteration'].call(this, data);
					}

					if (calls['before-iteration-'+i]) {
						calls['before-iteration-'+i].call(this, data);
					}

					if (calls['after-iteration-'+i]) {
						calls['after-iteration-'+i].call(this, data);
					}


					if (calls['after-iteration']) {
						calls['after-iteration'].call(this, data);
					}
					i++;
				}
				
			}
		};
		
		return director;
	}
})();

try {
	module.exports = Orchestra;
} catch(e){
}